#INCL = ${TINE_INCL}
#LIBS = ${TINE_LIB}
#just hardwire them
INCL = ../../../include
LIBS = ../../../lib
TINEEXE = cas
TINELIB = libtinemt.a
ARCSRC = ../../shared
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/srvip.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/swaplib.h \
	${INCL}/dbtools.h \
	${INCL}/swaplib.h \
	${INCL}/almlib.h 

CPP = g++ -c -g -I. -I${INCL} -I${ARCSRC}
CC = clang -m64 -fPIC -w -c -DMULTITHREADED -g -I. -I${INCL} -I${ARCSRC}
CCL = clang -m64 -fPIC -w -g
LM = -lm -lpthread 

${TINEEXE}: devsrv.o caseqm.o apceqm.o arctools.o
	${CCL} -o ${TINEEXE} devsrv.o caseqm.o apceqm.o arctools.o ${LIBS}/${TINELIB} ${LM}
	chmod a+x ${TINEEXE}

devsrv.o: devsrv.c ${HDRS}
	${CC} devsrv.c

caseqm.o: caseqm.c caseqm.h ${HDRS}
	${CC} caseqm.c

apceqm.o: ${ARCSRC}/apceqm.c ${ARCSRC}/apceqm.h ${HDRS}
	${CC} ${ARCSRC}/apceqm.c

arctools.o: ${ARCSRC}/arctools.c ${ARCSRC}/arctools.h ${HDRS}
	${CC} ${ARCSRC}/arctools.c

clean:
	rm -f *.o
