#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include "tine.h"
//#include "tgweqm.h"

#define CMBEQM_TAG "CMBEQM"

#define PRP_POLL_INTERVAL 1001
#define PRP_STOPALL 1002
#define PRP_STARTALL 1003

char thisFecContext[32] = "TEST";
char thisFecServer[32];
char thisFecName[32];
char thisSubsystem[16] = "MISC";
char thisFecDescription[64];
char thisFecLocation[64] = "unknown";
char thisFecResponsible[32] = "";
int thisFecPort = 0;
int thisFecCapacity = 100; // this maximum number of servers to combobulate ...
extern char *gUsageString;

// cover some non-exported routines from the lib ...
short GetElevatedMcaFmt(short fmt)
{
  switch (fmt)
  {
  case CF_INT16:
  case CF_INT32: return CF_INTINT;
  case CF_FLOAT: return CF_FLTINT;
  case CF_DOUBLE: return CF_DBLDBL;
  case CF_NAME16: return CF_NAME16I;
  case CF_NAME32: return CF_NAME32I;
  case CF_NAME64: return CF_NAME64I;
  default: break;
  }
  return fmt;
}
int IsNumFmt(short fmt)
{
  switch (LFMT(fmt))
  {
    case CF_INT16:
    case CF_INT32:
    case CF_INT64:
    case CF_FLOAT:
    case CF_DOUBLE:
      return TRUE;
    default:
      break;
  }
  return FALSE;
}
int IsIntFmt(short fmt)
{
  switch (LFMT(fmt))
  {
    case CF_INT16:
    case CF_INT32:
    case CF_INT64:
      return TRUE;
    default:
      break;
  }
  return FALSE;
}
UINT32 g_status;
void cbCmb(int id,int cc,void *ref);

void cmbeqm_bkg(void)
{
  ClearAlarm(CMBEQM_TAG,-1);

  //SetAlarm(CMBEQM_TAG,devNr,almCode,almFlag);
}

typedef struct
{
  char name[64];
  char alias[64];
  int number;
  int disabled;
} TDevs;
TDevs *tdevs = NULL;

typedef struct TPrp 
{
  char srv[64];
  char prp[64];
  char dev[64];
  char dsc[64];
  int offset;
  int ndevs;
  TDevs *devlst;
  int lid;
  int cc;
  int lsts;
  int useTgtDev;
  short *sts;
  BYTE *data;
  double ts;
  float shift;
  float scale;
  float defaultValue;
  float freserved;
  XTCBFCNP cb;
  struct TPrp *nxt;
  struct TPrp *prv;
} TPrp;

typedef struct CPrp 
{
  TPrp *tprps; // the linked list of property items
  int nprps; // length of the TPrp linked list
  int pid; // property id
  int npid; // .NAM property id
  int tmr; // timer interval in ms
  int needsScale;
  int fmt; // export format
  int fld; // default field index (for compound data types)
  char prp[64]; // this property name
  char dsc[64]; // this property description
  DTYPE dout;
} CPrp;

CPrp *cprps = NULL;
int ncprps = 0;

typedef struct CCPrpInfo
{
  char prp[64];
  char dsc[64];
  char prp_alias[64]; // this property name
  char fmt_str[16];
  char fmt_exp[16]; // format to export
  float shift;
  float scale;
  float defaultValue;
  int fld; // default field index for compound formats
  int tmr;
  int pid;
} CCPrpInfo;

CSVCOLUMN csvCPrpsFileColumns[] =
{
  { "PROPERTY","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CCPrpInfo,prp),NULL,0 },
  { "PROPERTY_ALIAS","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CCPrpInfo,prp_alias),NULL,0 },
  { "DESCRIPTION","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CCPrpInfo,dsc),NULL,0 },
  { "FORMAT","",0,CF_TEXT,16,(BYTE *)OFFSETIN(CCPrpInfo,fmt_str),NULL,0 },
  { "FORMAT_EXPORT","",0,CF_TEXT,16,(BYTE *)OFFSETIN(CCPrpInfo,fmt_exp),NULL,0 },
  { "SHIFT","0.0",0,CF_FLOAT,1,(BYTE *)OFFSETIN(CCPrpInfo,shift),NULL,0 },
  { "SCALE","1.0",0,CF_FLOAT,1,(BYTE *)OFFSETIN(CCPrpInfo,scale),NULL,0 },
  { "FIELD_INDEX","-1",0,CF_INT32,1,(BYTE *)OFFSETIN(CCPrpInfo,fld),NULL,0 },
  { "DEFAULT_VALUE","0.0",0,CF_FLOAT,1,(BYTE *)OFFSETIN(CCPrpInfo,defaultValue),NULL,0 },
  { "INTERVAL","1000",0,CF_INT32,1,(BYTE *)OFFSETIN(CCPrpInfo,tmr),NULL,0 },
};
CSVDB csvCPrpsFileDb =
{
  csvCPrpsFileColumns,
  sizeof(csvCPrpsFileColumns) / sizeof(csvCPrpsFileColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(CCPrpInfo),
  0
};

typedef struct CPrpInfo 
{
  char srv[64];
  char prp[64];
  char dsc[64];
  char prp_alias[64]; // this property name
  char dev[64];
  char dev_alias[64]; // this device name
  char fmt_str[16];
  char fmt_exp[16]; // format to export
  int  siz; // capacity
  int  fld; // default field index for compound formats
  int  disabled;
  int  done;
  int  prpLstSiz;
  int  tmr;
  float shift;
  float scale;
  float defaultValue;
  CCPrpInfo *prpLst;
} CPrpInfo;

CSVCOLUMN csvTPrpsFileColumns[] = 
{
  { "SERVER","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CPrpInfo,srv),NULL,0 },
  { "PROPERTY","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CPrpInfo,prp),NULL,0 },
  { "PROPERTY_ALIAS","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CPrpInfo,prp_alias),NULL,0 },
  { "DEVICE","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CPrpInfo,dev),NULL,0 },
  { "DEVICE_ALIAS","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CPrpInfo,dev_alias),NULL,0 },
  { "DESCRIPTION","",0,CF_TEXT,64,(BYTE *)OFFSETIN(CPrpInfo,dsc),NULL,0 },
  { "FORMAT","",0,CF_TEXT,16,(BYTE *)OFFSETIN(CPrpInfo,fmt_str),NULL,0 },
  { "FORMAT_EXPORT","",0,CF_TEXT,16,(BYTE *)OFFSETIN(CPrpInfo,fmt_exp),NULL,0 },
  { "CAPACITY","",0,CF_INT32,1,(BYTE *)OFFSETIN(CPrpInfo,siz),NULL,0 },
  { "INTERVAL","1000",0,CF_INT32,1,(BYTE *)OFFSETIN(CPrpInfo,tmr),NULL,0 },
  { "DISABLED","FALSE",0,CF_BOOLEAN,1,(BYTE *)OFFSETIN(CPrpInfo,disabled),NULL,0 },
  { "SHIFT","0.0",0,CF_FLOAT,1,(BYTE *)OFFSETIN(CPrpInfo,shift),NULL,0 },
  { "SCALE","1.0",0,CF_FLOAT,1,(BYTE *)OFFSETIN(CPrpInfo,scale),NULL,0 },
  { "FIELD_INDEX","-1",0,CF_INT32,1,(BYTE *)OFFSETIN(CPrpInfo,fld),NULL,0 },
  { "DEFAULT_VALUE","0.0",0,CF_FLOAT,1,(BYTE *)OFFSETIN(CPrpInfo,defaultValue),NULL,0 },
};
CSVDB csvTPrpsFileDb =
{
  csvTPrpsFileColumns,
  sizeof(csvTPrpsFileColumns)/sizeof(csvTPrpsFileColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(CPrpInfo),
  0
};

CPrpInfo *cprpinfo = NULL;

int isGrouped = FALSE;
int isUseOnError = TRUE;
int gMonitorInterval = 1000;

NAME64 dbuf[1024];
int bufsiz = 1024;

// LockLinkData(), UnlockLinkData() in EQM -> apply scale and offset there !
void cbCmb(int id,int cc,void *ref)
{
  TPrp *tp = (TPrp *)ref;
  double ts;
  if (tp == NULL) return;
  tp->lsts = cc;
  ts = cc == 0 ? GetDataTimeStamp() : MakeDataTimeStamp();
  tp->ts = ts;
  if (cc == 0 || isUseOnError) cprps[id].dout.dTimeStamp = ts;
}
CSVCOLUMN csvTDevsFileColumns[] = 
{
  { "DEVICE_NAME","",0,CF_TEXT,64,(BYTE *)OFFSETIN(TDevs,name),NULL,0 },
  { "DEVICE_ALIAS","",0,CF_TEXT,64,(BYTE *)OFFSETIN(TDevs,alias),NULL,0 },
  { "DEVICE_NUMBER","",0,CF_INT32,1,(BYTE *)OFFSETIN(TDevs,number),NULL,0 },
//  { "DISABLED","",0,CF_BOOLEAN,1,(BYTE *)OFFSETIN(TDevs,disabled),NULL,0 },
};
CSVDB csvTDevsFileDb =
{
  csvTDevsFileColumns,
  sizeof(csvTDevsFileColumns)/sizeof(csvTDevsFileColumns[0]),
  0,
  csvStdInit,
  csvStdIterator,
  csvStdExit,
  0,
  NULL,
  sizeof(TDevs),
  0
};

char *makeTgtDevName(char *srv,char *dev)
{
  static char tgt[128];
  if (srv[0] == '/')
    sprintf(tgt, "%.64s/%.64s", srv, dev);
  else
    sprintf(tgt, "/%.32s/%.32s/%.64s", thisFecContext, srv, dev);
  return tgt;
}

#define punt(t,c) { tineDebug=1; feclog("%s : %.32s",t,cc2str(c)); exit(1); }
int assignDevListToPrp(TPrp *prp, CPrpInfo *pinf)
{ // read file, acq list, or take as is
  TDevs *devlst = NULL;
  int i, cc = 0, isWldCrd = FALSE;
  char cpath[256], fn[64], tgt[132], *ctx = thisFecContext, *srv, *dev;

  if (prp == NULL || pinf == NULL) return -argument_list_error;
  strncpy(tgt, prp->srv, 64); tgt[64] = 0;
  if (tgt[0] == '/') tokenizeFullName(tgt, &ctx, &srv, &dev); else srv = prp->srv;
  sprintf(cpath, "%s%c%.32s%c%.32s%c%.64s%c", 
    SystemGetStartupDirectory(), FS_DELIMITER, ctx, FS_DELIMITER, srv, FS_DELIMITER, prp->prp, FS_DELIMITER);
  fn[0] = 0;
  isWldCrd = strchr(pinf->dev, '*') != NULL;
  if (isWldCrd || strlen(pinf->dev) == 0)
  { // acquire names from server
    bufsiz = 1024;
    if (isWldCrd && strlen(pinf->dev) > 1 && pinf->siz > 1)
    { // wildcard distinguished device list ...
      strncpy(prp->dev, pinf->dev, 64);
      prp->useTgtDev = TRUE;
    }
    if ((cc=GetSystemDevices(makeTgtDevName(prp->srv,"#0"), prp->prp, dbuf, &bufsiz)) == 0)
    {
      int k, nlen, elen = 0, contains=TRUE, matches;
      char strc[72], *c, *s, *beginTok = NULL, *midTok = NULL, *endTok = NULL;
      char strpp[72], *pre = NULL, *post = NULL;
      if (strchr(pinf->dev_alias, '*') != NULL && strlen(pinf->dev_alias) > 1)
      { // device alias decorations: any other dev_alias will revert to using the acquired dev list !
        strncpy(strpp, pinf->dev_alias, 64); strpp[64] = 0; s = strpp;
        if (*s == '*')
        { // no beginToken -> only a post fix
          while (*s == '*') s++;  // just in case ...
          if ((c = strchr(s, '*')) != NULL) *c = 0;  // just in case ...
          post = s;
        }
        else
        { // start with a pre fix
          pre = strpp;
          if ((s = strchr(strpp, '*')) != NULL)
          { // and there's a post fix ...
            *s++ = 0;
            while (*s == '*') s++; // just in case ...
            if ((c = strchr(s, '*')) != NULL) *c = 0; // just in case ...
            post = s;
          }
        }
        if (pre != NULL && strlen(pre) == 0) pre = NULL;
        if (post != NULL && strlen(post) == 0) post = NULL;
      }
      if (strlen(pinf->dev) > 1)
      { // targeted devices ...
        strncpy(strc, pinf->dev, 64); strc[64] = 0; s = strc;
        if (*s == '-')
        { // starts with a minus: skip those devices that match ...
          contains = FALSE;
          s++;
        }
        if (*s == '*')
        { // no beginToken
          while (*s == '*') s++;
          if ((c = strchr(s, '*')) != NULL)
          { /* there's a midToken ("*abc*") */
            *c = 0; midTok = s;
          }
          else
          { /* there's an end token */
            endTok = s;
          }
        }
        else
        {
          beginTok = s;
          if ((c = strchr(beginTok, '*')) != NULL)
          { /* found begin Token end */
            *c++ = 0;
            s = c; /* re-position (could still be an end token */
            while (*s == '*') s++; /* is it "abc*xyz" ? */
            if (strlen(s) > 0) endTok = s;
          }
        }
        if (endTok != NULL) elen = (int)strlen(endTok);
      }
      devlst = (TDevs *)calloc(bufsiz, sizeof(TDevs));
      if (devlst == NULL) punt("assignDevListToPrp", out_of_local_memory);
      for (i = 0, k = 0; i < bufsiz; i++)
      {
        nlen = MIN((int)strlen(dbuf[i].name),64);
        matches = TRUE;
        if (beginTok != NULL && strnicmp(dbuf[i].name, beginTok, strlen(beginTok))) matches = FALSE;
        if (midTok != NULL && strstr(dbuf[i].name, midTok) == NULL) matches = FALSE;
        if (endTok != NULL && strnicmp(&dbuf[i].name[nlen - elen], endTok, elen)) matches = FALSE;
        if (matches && !contains) continue;
        if (!matches && contains) continue;
        strncpy(devlst[k].name, dbuf[i].name, 64);
        // now prepare the alias ...
        if (pre == NULL && post == NULL)
        { // no pre or post fix instructions: take it as is
          strncpy(devlst[k].alias, dbuf[i].name, 64);
        }
        else
        {
          char *dn = dbuf[i].name;
          char *ppre = pre == NULL ? "" : pre;
          char *ppost = post == NULL ? "" : post;
          if (pre != NULL && *pre == '-')
          { // instruction to remove the prefix from the targeted name
            int plen = (int)strlen(pre) - 1;
            if (!strnicmp(dn, &pre[1], plen)) dn += plen;
            ppre = "";
          }
          if (post != NULL && *post == '-')
          { // instruction to remove the prefix from the targeted name
            int plen = (int)strlen(post) - 1;
            if ((c = strstr(dn, &post[1])) != NULL) *c = 0;
            ppost = "";
          }
          snprintf(devlst[k].alias, 64, "%s%.64s%s", ppre, dn, ppost);
        }
        devlst[k].number = k;
        k++;
      }
      prp->ndevs = k;
      prp->devlst = devlst;
      // write to cache file
      MakeDirectoryPath(cpath, TRUE);
#     ifndef USE_CSVWRITEFILE
      {
        char fn[256];
        FILE *fp = NULL;
        sprintf(fn, "%.132sdevices.csv", cpath);
        if ((fp = fopen(fn, "w")) != NULL)
        {
          fprintf(fp, "DEVICE_NAME, DEVICE_ALIAS, DEVICE_NUMBER\n");
          for (i = 0; i < prp->ndevs; i++)
            fprintf(fp, "%.64s, %.64s, %d\n", devlst[i].name, devlst[i].alias, i);
          fclose(fp);
        }
      }
#     else
      csvTDevsFileDb.siz = prp->ndevs;
      csvTDevsFileDb.tgt = (BYTE *)prp->devlst;
      csvTDevsFileDb.tgt_flgs = CSVDB_INITIALIZED | CSVDB_PREALLOC;
      csvStdInit(&csvTDevsFileDb);
      csvWriteFile(cpath, "devices.csv", &csvTDevsFileDb);
#     endif
      ccerr(0); // we're done !
    }
    else
    { // error contacting server (read from cache file)!
      strcpy(fn, "devices.csv");
    }
  }
  if (strstr(pinf->dev, ".csv") != NULL)
  { // get device list explicitly from file
    if (!strcmp(pinf->dev, ".csv")) strcpy(fn, "devices.csv"); else strncpy(fn, pinf->dev, 64);
  }
  if (strlen(fn) > 0)
  {
    csvTDevsFileDb.siz = 0; csvTDevsFileDb.tgt = NULL;
    cc = csvReadFile(cpath, fn, &csvTDevsFileDb, (void **)&prp->devlst);
    if (cc == 0) prp->ndevs = csvTDevsFileDb.siz;
    ccerr(cc);
  }
  // device name and alias given directly in config file ...
  devlst = (TDevs *)calloc(1, sizeof(TDevs));
  if (devlst == NULL) punt("assignDevListToPrp", out_of_local_memory);
  strncpy(devlst[0].name, pinf->dev, 64);
  if (strlen(pinf->dev_alias) == 0) strncpy(pinf->dev_alias, pinf->dev, 64);
  strncpy(devlst[0].alias, pinf->dev_alias, 64);
  devlst[0].disabled = pinf->disabled;  // flag as disabled if declared so here ...
  prp->devlst = devlst;
  prp->ndevs = 1;
err:
  return cc ? -cc : prp->ndevs;
}
void applyDefaultToDTYPE(DTYPE *d, float defaultValue)
{
  if (d == NULL) return;
  switch (d->dFormat)
  {
    case CF_SPECTRUM:
    {
      USPECTRUM *sp = (USPECTRUM *)d->data.vptr;
      sp->status = (int)defaultValue;
      sp->s_inc = defaultValue;
      sp->s_start = defaultValue;
      sp->tm = (int)defaultValue;
      break;
    }
    case CF_FLTINT:
    {
      FLTINT *v = (FLTINT *)d->data.vptr;
      v->fval = defaultValue;
      v->ival = (int)defaultValue;
      break;
    }
    case CF_INTINT:
    {
      INTINT *v = (INTINT *)d->data.vptr;
      v->i1val = (int)defaultValue;
      v->i2val = (int)defaultValue;
      break;
    }
    case CF_FLTFLT:
    {
      FLTFLT *v = (FLTFLT *)d->data.vptr;
      v->f1val = defaultValue;
      v->f2val = defaultValue;
      break;
    }
    case CF_DBLDBL:
    {
      DBLDBL *v = (DBLDBL *)d->data.vptr;
      v->d1val = defaultValue;
      v->d2val = (int)defaultValue;
      break;
    }
    case CF_INTINTINTINT:
    {
      DADDRESS *v = (DADDRESS *)d->data.vptr;
      v->i1val = (int)defaultValue;
      v->i2val = (int)defaultValue;
      v->i3val = (int)defaultValue;
      v->i4val = (int)defaultValue;
      break;
    }
    default:
      if (IsNumFmt(d->dFormat))
      { // this'll work for the 1st value ...
        PutValuesFromFloatEx(d, &defaultValue, 1, 0);
      }
      break;
  }
}
char *getTgtDevice(CPrp *cprp, TPrp *tprp)
{
  if (tprp->devlst[0].name[0] != '$')
  {
    if (tprp->useTgtDev) return tprp->dev;
    return tprp->devlst[0].name;
  }
  if (!strnicmp(tprp->devlst[0].name, "$PRP", 4)) return cprp->prp;
  if (!strnicmp(tprp->devlst[0].name, "$PROP", 5)) return cprp->prp;
  if (!strnicmp(tprp->devlst[0].name, "$DSC", 4)) return cprp->dsc;
  if (!strnicmp(tprp->devlst[0].name, "$DESC", 5)) return cprp->dsc;
  return tprp->devlst[0].name;
}

int nTotalLinks = 0;
#define LINKTABLE_SIZE 2048
int gLinkTableSize = LINKTABLE_SIZE;
#define CMBCFG_FILENAME "combobulate.csv"
char cmbCfgFile[64] = CMBCFG_FILENAME;
void cmbeqm_ini(void)
{
  char prp[72] = "";
  char wd[128];
  int i,j,k=-1,n,nt,p = 0,np = -1,cc = 0, efmt;
  DTYPE dout,dmca;
  int keep_scanning = FALSE, use_local = FALSE, mode = CM_TIMER;
  int use_alias_devices = FALSE, has_devices_from_target = FALSE, tgt_composite = FALSE;

  int fsiz, hsiz, ndevs, offset;
  TPrp *tprp, *nprp;
  
  char *tdevnam = "";

  DTYPEZERO(dout); DTYPEZERO(dmca);
  nTotalLinks = 0;
  //if (isGrouped) mode |= CM_GROUPED; << NO! there's only one callback for everyone !
  if (isUseOnError) mode |= CM_USEONERROR;

  snprintf(wd, 128, "%s%c", SystemGetStartupDirectory(), FS_DELIMITER);
  if ((cc=csvReadFile(wd, cmbCfgFile,&csvTPrpsFileDb,(void **)&cprpinfo)) != 0)
  {
    tineDebug = 1;
    feclog("cannot read gateway properties file %s! : %.32s",cmbCfgFile,cc2str(cc));
    exit(1);
  }
  n = csvTPrpsFileDb.siz; nt = 0;
  // quick check for property files ...
  for (i = 0; i < n; i++)
  {
    if (strstr(cprpinfo[i].prp, ".csv") != NULL && strlen(cprpinfo[i].prp) > 4)
    { // properties given in a list (and not as is)
      if (strlen(cprpinfo[i].prp_alias) == 0) strncpy(cprpinfo[i].prp_alias, cprpinfo[i].prp, 64);
      if (strnicmp(cprpinfo[i].prp, prp, 64) == 0)
      { // same file -> copy the reference !
        cprpinfo[i].prpLst = (CCPrpInfo *)csvCPrpsFileDb.tgt; 
        cprpinfo[i].prpLstSiz = csvCPrpsFileDb.siz;
        nt += cprpinfo[i].prpLstSiz;
        continue;
      }
      strncpy(prp, cprpinfo[i].prp, 64);
      csvCPrpsFileDb.siz = 0; csvCPrpsFileDb.tgt = NULL;
      if ((cc=csvReadFile(wd, prp, &csvCPrpsFileDb, (void **)&cprpinfo[i].prpLst)) != 0)
      {
        feclog("cannot read gateway properties list file %s%.64s ! : %.32s", wd, prp, cc2str(cc));
        exit(1);
      }
      cprpinfo[i].prpLstSiz = csvCPrpsFileDb.siz;
      for (j = 0; j < csvCPrpsFileDb.siz; j++)
      { // check for empty important entries ...
        if (strlen(cprpinfo[i].prpLst[j].prp_alias) == 0) 
          strncpy(cprpinfo[i].prpLst[j].prp_alias, cprpinfo[i].prpLst[j].prp, 64);
        if (strlen(cprpinfo[i].prpLst[j].fmt_exp) == 0)
          strncpy(cprpinfo[i].prpLst[j].fmt_exp, cprpinfo[i].prpLst[j].fmt_str, 16);
      }
    }
    else
    { // single property given as is ...
      cprpinfo[i].prpLst = (CCPrpInfo *)SystemCalloc(1, sizeof(CCPrpInfo));
      if (cprpinfo[i].prpLst == NULL)
      {
        feclog("cannot allocate memory for %.64s !", cprpinfo[i].prp);
        exit(1);
      }
      strncpy(cprpinfo[i].prpLst[0].prp, cprpinfo[i].prp, 64);
      if (strlen(cprpinfo[i].prp_alias) == 0) strncpy(cprpinfo[i].prp_alias, cprpinfo[i].prp, 64);
      strncpy(cprpinfo[i].prpLst[0].prp_alias, cprpinfo[i].prp_alias, 64);
      strncpy(cprpinfo[i].prpLst[0].dsc, cprpinfo[i].dsc, 64);
      strncpy(cprpinfo[i].prpLst[0].fmt_str, cprpinfo[i].fmt_str, 16);
      if (strlen(cprpinfo[i].fmt_exp) == 0) 
        strncpy(cprpinfo[i].fmt_exp, cprpinfo[i].fmt_str, 16);
      strncpy(cprpinfo[i].prpLst[0].fmt_exp, cprpinfo[i].fmt_exp, 16);
      cprpinfo[i].prpLst[0].defaultValue = cprpinfo[i].defaultValue;
      if (cprpinfo[i].scale == 0) cprpinfo[i].scale = 1.0; // double check !
      cprpinfo[i].prpLst[0].scale = cprpinfo[i].scale;
      cprpinfo[i].prpLst[0].shift = cprpinfo[i].shift;
      cprpinfo[i].prpLst[0].fld = cprpinfo[i].fld;
      cprpinfo[i].prpLst[0].tmr = cprpinfo[i].tmr;
      cprpinfo[i].prpLstSiz = 1;
      if (strlen(cprpinfo[i].dev_alias) == 0)
        strncpy(cprpinfo[i].dev_alias, cprpinfo[i].dev, 64);
    }
    nt += cprpinfo[i].prpLstSiz; // augment the worst case total number ...
  }
  cprps = (CPrp *)calloc(nt,sizeof(CPrp)); // worst case
  if (cprps == NULL) punt("cmbeqm_ini",out_of_local_memory);
  // line up entries per 'property alias' (the combobulated export property)
  while (TRUE)
  {
    keep_scanning = FALSE;
    for (i = p; i < n; i++)
    {
      if (cprpinfo[i].done) continue;
      keep_scanning = TRUE;
      if (strnicmp(cprpinfo[i].prp_alias, cprpinfo[p].prp_alias, 64))
      { // the next alias property to check for
        if (np < 0) np = i;
      }
      else
      { // latched another to target (or the first one)
        cprpinfo[i].done = TRUE;
        for (j = 0; j < cprpinfo[p].prpLstSiz; j++)
        { // work thru the property list (often a list of 1)
          if (i == p)
          { // the first one!
            k++; // k = last properties k + 1 and loop over range
            cprps[k].pid = k;
            cprpinfo[i].prpLst[j].pid = k;
            strncpy(cprps[k].prp, cprpinfo[i].prpLst[j].prp_alias, 64);
            DTYPEZERO(cprps[k].dout);
            cprps[k].dout.dFormat = GetFormatFromString(cprpinfo[i].prpLst[j].fmt_str);
            strncpy(cprps[k].dsc, cprpinfo[i].prpLst[j].dsc, 64);
            cprps[k].fmt = GetFormatFromString(cprpinfo[i].prpLst[j].fmt_exp);
            cprps[k].fld = cprpinfo[i].prpLst[j].fld;
          }
          else
          { // additional device entries with the same property (properties)
            k = cprpinfo[p].prpLst[j].pid;
          }
          tprp = (TPrp *)calloc(1, sizeof(TPrp));
          if (tprp == NULL) punt("cmbeqm_ini", out_of_local_memory);
          strncpy(tprp->srv, cprpinfo[i].srv, 64);
          strncpy(tprp->prp, cprpinfo[i].prpLst[j].prp, 64);
          strncpy(tprp->dsc, cprpinfo[i].prpLst[j].dsc, 64);
          tprp->shift = cprpinfo[i].prpLst[j].shift;
          tprp->scale = cprpinfo[i].prpLst[j].scale;
          tprp->defaultValue = cprpinfo[i].prpLst[j].defaultValue;
          tprp->ndevs = assignDevListToPrp(tprp, &cprpinfo[i]); // read file, acq list, or take as is
          tprp->nxt = cprps[k].tprps;
          if (cprps[k].tprps != NULL) cprps[k].tprps->prv = tprp;
          cprps[k].tprps = tprp;
          cprps[k].dout.dArrayLength += tprp->ndevs;
          cprps[k].tmr = cprpinfo[i].prpLst[j].tmr;
          cprps[k].nprps++; // number of accessed target properties (links)
        }
      }
    }
    if (np < 0) break;
    if (!keep_scanning) break;
    p = np; np = -1;
  }
  ncprps = k + 1;
  for (i=0; i<ncprps; i++)
  {
    fsiz = fmtsizeof(cprps[i].dout.dFormat);
    hsiz = getFormatHeaderSize(cprps[i].dout.dFormat);
    fsiz += hsiz;
    cprps[i].dout.data.bptr = (BYTE *)calloc(cprps[i].dout.dArrayLength,fsiz);
    ndevs = 0; tprp = NULL;
    for (nprp = cprps[i].tprps; nprp != NULL; nprp = nprp->nxt) tprp = nprp; // find the end
    while (tprp != NULL)
    { // use segments of DTYPE in the tprps list ...
      offset = ndevs * fsiz;
      tprp->data = cprps[i].dout.data.bptr + offset;
      dout.dArrayLength = tprp->ndevs;
      dout.dFormat = cprps[i].dout.dFormat;
      dout.data.bptr = tprp->data;
      applyDefaultToDTYPE(&dout, tprp->defaultValue);
      if (tprp->devlst != NULL && !tprp->devlst[0].disabled)
      {
        tdevnam = getTgtDevice(&cprps[i], tprp);
        tprp->lid = AttachLinkEx2(makeTgtDevName(tprp->srv, tdevnam), tprp->prp, &dout, NULL, CA_READ, cprps[i].tmr, cbCmb, mode, i, tprp);
      }
      else
      {
        tprp->lsts = not_running;
      }
      tprp->offset = ndevs;
      ndevs += tprp->ndevs;
      if (tprp->scale != 1 || tprp->shift != 0) cprps[i].needsScale = TRUE;
      tprp = tprp->prv; // backwards thru the list => forward ordered
      nTotalLinks++;
      if (nTotalLinks > gLinkTableSize - 100)
      { // realloc ...
        gLinkTableSize += 1024;
        SetConnectionTableCapacity(gLinkTableSize);
      }
    }
    efmt = GetElevatedMcaFmt(cprps[i].fmt);
    dmca.dArrayLength = cprps[i].dout.dArrayLength;
    if (cprps[i].fmt != efmt)
    {
      dmca.dFormat = efmt;
      cprps[i].pid = RegisterPropertyInformation(CMBEQM_TAG, cprps[i].prp, &dmca, NULL, CA_READ, AT_CHANNEL, cprps[i].dout.dArrayLength, cprps[i].dsc, i, NULL);
    }
    dmca.dFormat = cprps[i].fmt;
    cprps[i].pid = RegisterPropertyInformation(CMBEQM_TAG, cprps[i].prp, &dmca, NULL, CA_READ, AT_CHANNEL, cprps[i].dout.dArrayLength, cprps[i].dsc, i, NULL);
    sprintf(prp, "%.60s.NAM", cprps[i].prp);
    dmca.dFormat = CF_NAME64;
    cprps[i].npid = RegisterPropertyInformation(CMBEQM_TAG, prp, &dmca, NULL, CA_READ, AT_CHANNEL, cprps[i].dout.dArrayLength, "channel names", ncprps+i, NULL);
  }    

  RegisterPropertyInformation(CMBEQM_TAG,"Monitor.PollingInterval",&dout,NULL,CA_READ|CA_WRITE,AT_SCALAR,1,"[500:10000 ms]monitor polling interval",PRP_POLL_INTERVAL,NULL);
  RegisterPropertyInformation(CMBEQM_TAG,"Monitor.StopAll",NULL,NULL,CA_WRITE,AT_SCALAR,0,"Stop all monitoring",PRP_STOPALL,NULL);
  RegisterPropertyInformation(CMBEQM_TAG,"Monitor.StartAll",NULL,NULL,CA_WRITE,AT_SCALAR,0,"Stop all monitoring",PRP_STARTALL,NULL);
  for (i=0; i<ncprps; i++)
  { // the .NAM properties will have their own lists ...
    RegisterDeviceName(CMBEQM_TAG, cprps[i].prp,i);
  }
  AssignNumDevices(CMBEQM_TAG, ncprps);
  SetServerCycleIdle(FALSE);
}

void start_links(int pid)
{
  int i,cc = 0,mode=CM_TIMER;
  int fsiz, hsiz, ndevs, offset;
  DTYPE dout,din;
  TPrp *tprp;
  char *tdevnam = "";
//  if (isGrouped) mode |= CM_GROUPED;
  if (isUseOnError) mode |= CM_USEONERROR;
  DTYPEZERO(dout); DTYPEZERO(din);

  for (i = 0; i < ncprps; i++)
  {
    if (pid >= 0 && i != pid) continue;
    fsiz = fmtsizeof(cprps[i].dout.dFormat);
    hsiz = getFormatHeaderSize(cprps[i].dout.dFormat);
    fsiz += hsiz;
    cprps[i].dout.data.bptr = (BYTE *)calloc(cprps[i].dout.dArrayLength, fsiz);
    ndevs = 0;
    for (tprp = cprps[i].tprps; tprp != NULL; tprp = tprp->nxt)
    { // use segments of DTYPE in the tprps list ...
      offset = ndevs * fsiz;
      if (hsiz > 0) tprp->ndevs = 1; // guarantee this !
      tprp->data = cprps[i].dout.data.bptr + offset;
      dout.dArrayLength = tprp->ndevs;
      dout.dFormat = cprps[i].dout.dFormat;
      dout.data.bptr = tprp->data;
      applyDefaultToDTYPE(&dout, tprp->defaultValue);
      if (tprp->devlst != NULL && !tprp->devlst[0].disabled)
      {
        tdevnam = getTgtDevice(&cprps[i], tprp);
        tprp->lid = AttachLinkEx2(makeTgtDevName(tprp->srv, tdevnam), tprp->prp, &dout, NULL, CA_READ, cprps[i].tmr, cbCmb, mode, i, tprp);
      }
      else
      {
        tprp->lsts = not_running;
      }
      tprp->offset = ndevs;
      ndevs += tprp->ndevs;
    }
  }
  return;
}
void stop_links(int pid)
{
  int i;
  TPrp *tprp;
  for (i = 0; i < ncprps; i++)
  {
    if (pid >= 0 && i != pid) continue;
    for (tprp = cprps[i].tprps; tprp != NULL; tprp = tprp->nxt)
    {
      if (tprp->devlst != NULL && !tprp->devlst[0].disabled)
      {
        CloseLink(tprp->lid);
      }
    }
  }
}
void cmbeqm_exi(void)
{
  stop_links(-1);
}

int cmbeqm(char *devName,char *devProperty,DTYPE *dout, DTYPE *din,short access)
{
  int devnr,prpid,ndevs,i,cc;

  prpid = GetPropertyId(CMBEQM_TAG,devProperty);
  if (prpid < 0) return illegal_property;

  switch (prpid)
  {
    case PRP_POLL_INTERVAL:
      cc = illegal_read_write;
      if ((i = GetPropertyId(CMBEQM_TAG, devName)) < 0) return illegal_device;
      if (access & CA_WRITE)
      {
        int tmr;
        if (din->dArrayLength != 1) return dimension_error;
        if ((cc=GetValuesAsLong(din,&tmr,1)) != 0) return cc;
        cprps[i].tmr = tmr;
        stop_links(i);
        start_links(i);
      }
      if (dout->dArrayLength > 0)
        cc = PutValuesFromLong(dout,&cprps[i].tmr,1);
      return cc;
    case PRP_STOPALL:
      if ((access & CA_WRITE) == 0) return illegal_read_write;
      if ((i = GetPropertyId(CMBEQM_TAG, devName)) < 0) return illegal_device;
      stop_links(i);
      return 0;
    case PRP_STARTALL:
      if ((access & CA_WRITE) == 0) return illegal_read_write;
      if ((i = GetPropertyId(CMBEQM_TAG, devName)) < 0) return illegal_device;
      start_links(i);
      return 0;
    default:
      if (prpid < ncprps)
      { // specific property
        int fsiz = fmtsizeof(cprps[prpid].dout.dFormat);
        int hsiz = getFormatHeaderSize(cprps[prpid].dout.dFormat);
        int efmt = GetElevatedMcaFmt(cprps[prpid].dout.dFormat);
        int needsScale = cprps[prpid].needsScale;
        int needsElevation = cprps[prpid].dout.dFormat != efmt && dout->dFormat == efmt;
        if (!IsNumFmt(cprps[prpid].dout.dFormat)) needsScale = needsElevation = FALSE;
        LockLinkData();
        fsiz += hsiz;
        dout->dTimeStamp = cprps[prpid].dout.dTimeStamp;
        devnr = GetDeviceNumberEx(CMBEQM_TAG, devName, devProperty);
        if (devnr < 0) ccerr(illegal_device);
        ndevs = cprps[prpid].dout.dArrayLength;
        if (dout->dArrayLength >(UINT32)ndevs) dout->dArrayLength = (UINT32)ndevs;
        if (needsScale || needsElevation)
        { // must be a number type
          SINT16 sval, *svals = NULL;
          SINT32 ival, *ivals = NULL;
          SINT64 lval, *lvals = NULL;
          float fval, *fvals = NULL;
          double dval, *dvals = NULL;
          BYTE *bvals = NULL;
          int n, k = 0;
          TPrp *tp = NULL, *np;
          for (np = cprps[prpid].tprps; np != NULL; np = np->nxt) tp = np; // find the end
          cc = 0;
          if (!needsElevation)
          { // need to allocate a collection buffer
            if ((bvals = (BYTE *)calloc(dout->dArrayLength, fmtsizeof(dout->dFormat))) == NULL)
              return out_of_server_memory;
            svals = (SINT16 *)bvals;
            ivals = (SINT32 *)bvals;
            lvals = (SINT64 *)bvals;
            fvals = (float *)bvals;
            dvals = (double *)bvals;
          }
          while (tp != NULL && k < (int)dout->dArrayLength && cc == 0)
          {
            for (n = 0; n < tp->ndevs && k < (int)dout->dArrayLength; n++, k++)
            {
              switch (cprps[prpid].dout.dFormat)
              {
                case CF_INT16:
                  sval = cprps[prpid].dout.data.sptr[k];
                  if (tp->scale < 1)
                  {
                    fval = (float)sval;
                    fval *= tp->scale;
                    sval = (SINT16)fval;
                  }
                  else
                  {
                    sval *= (SINT16)tp->scale;
                  }
                  sval += (SINT16)tp->shift;
                  if (needsElevation)
                  {
                    ((INTINT *)dout->data.vptr)[k].i1val = (int)sval;
                    ((INTINT *)dout->data.vptr)[k].i2val = tp->lsts;
                  }
                  else
                  {
                    //dout->data.sptr[k] = sval;
                    svals[k] = sval;
                  }
                  break;
                case CF_INT32:
                  ival = cprps[prpid].dout.data.lptr[k];
                  if (tp->scale < 1)
                  {
                    dval = (double)ival;
                    dval *= tp->scale;
                    ival = (SINT32)dval;
                  }
                  else
                  {
                    ival *= (SINT32)tp->scale;
                  }
                  ival += (SINT32)tp->shift;
                  if (needsElevation)
                  {
                    ((INTINT *)dout->data.vptr)[k].i1val = ival;
                    ((INTINT *)dout->data.vptr)[k].i2val = tp->lsts;
                  }
                  else
                  {
                    //dout->data.lptr[k] = ival;
                    ivals[k] = ival;
                  }
                  break;
                case CF_INT64:
                  lval = cprps[prpid].dout.data.llptr[k];
                  if (tp->scale < 1)
                  {
                    dval = (double)ival;
                    dval *= tp->scale;
                    lval = (SINT64)dval;
                  }
                  else
                  {
                    lval *= (SINT64)tp->scale;
                  }
                  lval += (SINT64)tp->shift;
                  //dout->data.llptr[k] = lval;
                  lvals[k] = lval;
                  break;
                case CF_FLOAT:
                  fval = cprps[prpid].dout.data.fptr[k];
                  fval *= tp->scale;
                  fval += tp->shift;
                  if (needsElevation)
                  {
                    ((FLTINT *)dout->data.vptr)[k].fval = fval;
                    ((FLTINT *)dout->data.vptr)[k].ival = tp->lsts;
                  }
                  else
                  {
                    //dout->data.fptr[k] = fval;
                    fvals[k] = fval;
                  }
                  break;
                case CF_DOUBLE:
                  dval = cprps[prpid].dout.data.dptr[k];
                  dval *= (double)tp->scale;
                  dval += (double)tp->shift;
                  if (needsElevation)
                  {
                    ((DBLDBL *)dout->data.vptr)[k].d1val = dval;
                    ((DBLDBL *)dout->data.vptr)[k].d2val = (double)tp->lsts;
                  }
                  else
                  {
                    //dout->data.dptr[k] = dval;
                    dvals[k] = dval;
                  }
                  break;
                default:
                  cc = illegal_format;
                  break;
              }
            }
            tp = tp->prv;
          }
          if (bvals != NULL)
          { // needed a collection buffer!
            PutValuesFromAny(dout, bvals, cprps[prpid].dout.dFormat, 1, fsiz, ndevs, devnr);
            free(bvals);
          }
        }
        else
        { // normal case and a one-liner ...
          int fldIdx = cprps[prpid].fld, fldOff = 0, fldFmt = CF_NULL;
          cc = -1;
          switch (cprps[prpid].dout.dFormat)
          {
            case CF_USTRING:
              switch (dout->dFormat)
              {
                case CF_USTRING: break;
                case CF_NAME16:
                case CF_NAME32:
                case CF_NAME64:
                case CF_STRING:
                  cc = PutValuesFromString(dout, cprps[prpid].dout.data.cptr, cprps[prpid].dout.dFormat, ndevs, devnr);
                  break;
                case CF_FLOAT:
                case CF_DOUBLE:
                  fldOff = 4; fldFmt = CF_FLOAT;
                  cc = PutValuesFromAny(dout, cprps[prpid].dout.data.bptr + fldOff, fldFmt, 1, fsiz, ndevs, devnr);
                  break;
                default:
                  cc = illegal_format;
                  break;
              }
              break;
            case CF_SPECTRUM:
              if (din->dArrayLength == 1)
              {
                if ((cc = GetValuesAsLong(din, &fldIdx, 1)) != 0) ccerr(cc);
              }
              if (fldIdx < 0) fldIdx = 3;
              if (fldIdx == 0) fldFmt = CF_TEXT;
              else if (fldIdx == 1 || fldIdx == 4) fldFmt = CF_INT32;
              else fldFmt = CF_FLOAT;
              if (fldIdx > 0) fldOff = 76 + fldIdx * 4;
              cc = PutValuesFromAny(dout, cprps[prpid].dout.data.bptr + fldOff, fldFmt, 1, fsiz, ndevs, devnr);
              break;
            default: 
              if (din->dArrayLength == 1)
              {
                if ((cc = GetValuesAsLong(din, &fldIdx, 1)) != 0) ccerr(cc);
              }
              if (fldIdx >= 0)
              {
                if ((cc = GetFieldInFormat(cprps[prpid].dout.dFormat, NULL, NULL, fldIdx, &fldOff, &fldFmt)) != 0) ccerr(cc);
                cc = PutValuesFromAny(dout, cprps[prpid].dout.data.bptr + fldOff, fldFmt, 1, fsiz, ndevs, devnr);
              }
              break;
          }
          if (cc < 0)
          { // not handled in a special case above ...
            cc = PutValuesFromAny(dout, cprps[prpid].dout.data.vptr, cprps[prpid].dout.dFormat, 1, fsiz, ndevs, devnr);
          }
        }
err:
        UnlockLinkData();
        return cc;
      }
      { // a .NAM request
        int tpid, n, k=0;
        char *c, tprp[72];
        TPrp *tp = NULL, *np;
        NAME64 *dst = (NAME64 *)dout->data.vptr;
        strncpy(tprp, devProperty, 64);
        if ((c = strrchr(tprp, '.')) == NULL) return illegal_property;
        *c = 0;
        if ((tpid = GetPropertyId(CMBEQM_TAG, tprp)) < 0) return illegal_property;
        if (dout->dFormat != CF_NAME64) return illegal_format;
        for (np = cprps[tpid].tprps; np != NULL; np = np->nxt) tp = np; // find the end
        while (tp != NULL && k < (int)dout->dArrayLength)
        {
          for (n = 0; n < tp->ndevs && k < (int)dout->dArrayLength; n++)
            strncpy(dst[k++].name, tp->devlst[n].alias, DEVICE_NAME_SIZE);
          tp = tp->prv;
        }
        return 0;
      }
   }
   return 0;
}
char *getAbbreviatedFecName(char *srv, int maxlen)
{
  static char fec[FEC_NAME_SIZE + 8];
  int i, k, slen, sflen = 0;
  char *suf = NULL, tmp[EXPORT_NAME_SIZE + 8];
  strncpy(tmp, srv, EXPORT_NAME_SIZE); tmp[EXPORT_NAME_SIZE] = 0;
  slen = (int)strlen(tmp);
  for (i = slen - 1; i > 0 && isdigit(tmp[i]); i--);
  suf = &tmp[i + 1];
  if ((sflen = (int)strlen(suf)) > 5)
  { /* allow up to a 5-digit numerical name */
    suf = NULL;
    sflen = 0;
  }
  slen -= sflen;
  memset(fec, 0, FEC_NAME_SIZE + 8);
  for (i = 0, k = 0; i<slen && k<maxlen; i++)
  {
    if (tmp[i] == 0) break;
    if (tmp[i] == '*') continue;
    if (tmp[i] == '.') continue;
    if (tmp[i] == '_') continue;
    if (tmp[i] == '-') continue;
    fec[k++] = tmp[i];
  }
  if (sflen > 0)
  {
    if ((int)strlen(fec) > maxlen - sflen) fec[maxlen - sflen - 1] = 0;
    strncat(fec, suf, sflen);
  }
  return fec;
}
char *suggestFecName(char *ctx, char *srv, int maxlen)
{
  static char fec[FEC_NAME_SIZE + 8];
  int len;

  memset(fec, 0, FEC_NAME_SIZE + 8);
  if (srv == NULL) return fec;
  if (ctx != NULL)
  {
    char *c;
    if ((c = strstr(ctx, ".SIM")) != NULL) *c++ = 0;
    else if ((c = strstr(ctx, "_SIM")) != NULL) *c++ = 0;
    else if ((c = strstr(ctx, ".TEST")) != NULL) *c++ = 0;
    else if ((c = strstr(ctx, "_TEST")) != NULL) *c++ = 0;
    strncpy(fec, ctx, 2);
    if (c != NULL) strncat(fec, c, 1);
  }
  if (maxlen > FEC_NAME_SIZE) maxlen = FEC_NAME_SIZE;
  len = maxlen - (int)strlen(fec);
  strncat(fec, getAbbreviatedFecName(srv, len), len);
  strupr(fec);
  if ((int)strlen(fec) < (maxlen - 2) && strstr(fec, "FEC") == NULL) strcat(fec, "FEC");
  return fec;
}
void PreSystemInit(void)
{
  char *usr = getenv("USERNAME");
  if (strlen(thisFecServer) == 0) goto err;
  if (usr == NULL) usr = "UNKNOWN";
  if (strlen(thisFecName) == 0)
  {
    strncpy(thisFecName,suggestFecName(thisFecContext, thisFecServer, 16),16);
  }
  if (strlen(thisFecResponsible) == 0) strncpy(thisFecResponsible, usr, 32);
  if (thisFecPort == 0) thisFecPort = GetPortOffset(thisFecName);
  FeclogDepth = 1000;
  RegisterFecInformation(thisFecName, thisSubsystem, thisFecContext, thisFecDescription, thisFecLocation, "none", thisFecResponsible, (UINT16)thisFecPort);
  SetConnectionTableCapacity(gLinkTableSize);
  return;
err:
  printf("%s\n", gUsageString);
  exit(0);
}
void PostSystemInit(void)
{
  RegisterEquipmentModule(thisFecServer, CMBEQM_TAG, thisFecCapacity, cmbeqm, cmbeqm_ini, cmbeqm_bkg, 200, cmbeqm_exi);

}
