#INCL = ${TINE_INCL}
#LIBS = ${TINE_LIB}
#just hardwire them
INCL = ../../../include
LIBS = ../../../lib
ARCSRC = ../../shared
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/srvip.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/dbtools.h \
	${INCL}/swaplib.h \
	${INCL}/almlib.h

TINELIB = libtine.a

CC = g++ -c -g -I. -I${INCL} -I${ARCSRC}
CC = clang -m64 -fPIC -w -c -g -I. -I${INCL} -I${ARCSRC}
CCL = clang -m64 -fPIC -w -g
LM = -lm 

march: devsrv.o statebase.o mexeqm.o archbase.o archlib.o
	${CCL} -o march devsrv.o statebase.o mexeqm.o archbase.o archlib.o ${LIBS}/${TINELIB} ${LM}
	chmod a+x march

devsrv.o: devsrv.c app_version.h ${HDRS}
	${CC} devsrv.c

statebase.o: ${ARCSRC}/statebase.c ${ARCSRC}/archive.h ${HDRS}
	${CC} ${ARCSRC}/statebase.c 

mexeqm.o: ${ARCSRC}/mexeqm.c ${ARCSRC}/archive.h ${HDRS}
	${CC} ${ARCSRC}/mexeqm.c 

archbase.o: ${ARCSRC}/archbase.c ${ARCSRC}/archive.h ${HDRS}
	${CC} ${ARCSRC}/archbase.c 

archlib.o: ${ARCSRC}/archlib.c ${ARCSRC}/archive.h ${HDRS}
	${CC} ${ARCSRC}/archlib.c 

clean:
	rm -f *.o
