#INCL = ${TINE_INCL}
#LIBS = ${TINE_LIB}
#just hardwire them
INCL = ../../../include
LIBS = ../../../lib
ARCSRC = ../../shared
HDRS = ${INCL}/project.def \
	${INCL}/prolog.h \
	${INCL}/srvcore.h \
	${INCL}/errors.h \
	${INCL}/tinetype.h \
	${INCL}/tinedefs.h \
	${INCL}/swaplib.h \
	${INCL}/dbtools.h \
	${INCL}/almlib.h 

TINELIB = libtine.a

CPP = g++ -c -g -Wno-deprecated -I. -I${INCL} -I${ARCSRC}
CC = clang -m64 -fPIC -w -c -g -I. -I${INCL} -I${ARCSRC}
CCL = clang -m64 -fPIC -w -g
LM = -lm 

pmarch: arctools.o streqm.o apceqm.o arceqm.o devsrv.o
	${CCL} -o pmarch arctools.o streqm.o apceqm.o arceqm.o devsrv.o ${LIBS}/${TINELIB} ${LM}
	chmod a+x pmarch

devsrv.o: devsrv.c app_version.h ${HDRS} 
	${CC} devsrv.c

arctools.o: ${ARCSRC}/arctools.c ${ARCSRC}/arctools.h ${HDRS}
	${CC} ${ARCSRC}/arctools.c

streqm.o: streqm.c ${ARCSRC}/apceqm.h ${ARCSRC}/arctools.h ${HDRS}
	${CC} streqm.c 

apceqm.o: ${ARCSRC}/apceqm.c ${ARCSRC}/apceqm.h ${HDRS}
	${CC} ${ARCSRC}/apceqm.c 

arceqm.o: arceqm.c ${ARCSRC}/arceqm.h ${ARCSRC}/arctypes.h ${HDRS}
	${CC} arceqm.c

clean:
	rm -f *.o
