#include "tinedefs.h"
#include "errors.h"

_char erlst[][32] = {
  "success",
  "illegal line number",
  "illegal format specification",
  "illegal arithmetic expression",
  "ambiguous request",
  "illegal delimiter",
  "attempt to divide by zero",
  "working area full",
  "nonexistent name",
  "transport medium is invalid",
  "data size mismatch",
  "no data found in range",
  "not allocated",
  "nonexistent line addressed",
  "illegal data size",
  "i/o error",
  "illegal context",
  "runtime error",
  "system error",
  "hardware operation in progress",
  "parameter error",
  "file error",
  "resort to stream transport",
  "array dimension error",
  "square root of neg.number",
  "data buffer too small",
  "string too long",
  "ipx socket error",
  "net read error",
  "call not ready",
  "invalid transport size",
  "logarithm argument <= 0",
  "device not connected",
  "unauthorised action",
  "hardware error",
  "illegal device",
  "illegal property",
  "value out of range",
  "not implemented yet",
  "no such computer",
  "tagged struct is sealed",
  "syntax error",
  "no such file",
  "file already exists",
  "no file space",
  "link timeout",
  "remitted data lost",
  "end of file",
  "archive in progress",
  "server name in use",
  "no such column",
  "out of client memory",
  "network access required",
  "address unresolved",
  "invalid or missing property",
  "address unknown",
  "name unknown",
  "invalid keyword",
  "invalid link handle",
  "String expected",
  "out of local memory",
  "out of shared memory",
  "invalid structure tag",
  "invalid index",
  "illegal equipment name",
  "link error",
  "code failure",
  "nonexistent server",
  "function deprecated",
  "not supported",
  "parsing error",
  "illegal relational operator",
  "not allowed",
  "illegal read/write attempted",
  "out of server memory",
  "database not loaded",
  "illegal command",
  "resources exhausted",
  "header not found",
  "sedac error",
  "reacquire address",
  "semaphore error",
  "driver not installed",
  "hardware port not available",
  "asynchronous access required",
  "semaphore blocked",
  "nonexistent element",
  "nonexistent fec",
  "nonexistent client",
  "unable to lock the memory",
  "server not responding",
  "result not posted",
  "command not accepted",
  "operation timeout",
  "illegal network protocol",
  "gpib error",
  "rs232 error",
  "operation busy",
  "connection timeout",
  "illegal mode",
  "not owner",
  "not defined",
  "net write error",
  "invalid data",
  "software error",
  "access denied",
  "tcp not supported",
  "ipx not supported",
  "tcp host not resolved",
  "tcp connect error",
  "tcp socket error",
  "configuration error",
  "invalid return code",
  "link is blacklisted",
  "link exists",
  "alarms buffer full",
  "not exported",
  "is switching",
  "at limit",
  "get subscription id",
  "renegotiate contract",
  "server redirection",
  "value too high",
  "value too low",
  "warn too high",
  "warn too low",
  "wait for completion",
  "cannot select",
  "has query function",
  "not signalled",
  "call redirection",
  "udp socket error",
  "mutex error",
  "data not local",
  "name already exists",
  "already assigned",
  "invalid field",
  "multicast init error",
  "invalid multicast group",
  "nonexistent function",
  "use channel array",
  "invalid name",
  "invalid value",
  "device error",
  "device not ready",
  "device busy",
  "invalid time interval",
  "notification pending",
  "thread error",
  "process is terminating",
  "name server unknown",
  "access lock required",
  "not initialized",
  "invalid structure size",
  "canbus error",
  "profibus error",
  "data stale",
  "has bitfield tag",
  "not locked",
  "lock expired",
  "not registered",
  "nonexistent property",
  "memory overwrite",
  "server idle",
  "not applicable",
  "access locked",
  "invalid data reference",
  "has structure tag",
  "disk space is low",
  "disk space is very low",
  "information is static",
  "reset mca property",
  "record too long",
  "unix socket or pipe error",
  "shared memory error",
  "tcp connection closed",
  "service unavailable",
  "device offline",
  "out of sequence",
  "invalid data request",
  "use elevated channel array",
  "name not found",
  "out of tolerance"
};

int numErr = sizeof(erlst)/sizeof(erlst[0]);

TINE_EXPORT int GetErrorListSize(void) { return numErr; }

_char logLevelList[][8] = {
  "INFO",
  "WARN",
  "ERROR",
  "FATAL"
};

int numLogLevels = sizeof(logLevelList)/sizeof(logLevelList[0]);

TINE_EXPORT int GetLogLevelListSize(void) { return numLogLevels; }

