#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "tine.h"

extern int nofeclog;
extern int ListenForGlobals;
extern int ListenForMCasts;
int tdevs(char *dev);
int tdevlist(char *dev);

char *usageTxt[] = {
  "\nRetrieves a list of registered devices for the given device server\n",
  "tdevlist /<context>/<server> [/d=<debug level>]",
  "e.g. tdevlist /HERA/HEPBLM",
  "\nSee also: 'tservers', 'tproplist' for retrieving information",
};

#define nUsageLines (int)(sizeof(usageTxt)/sizeof(char *))

int main(int argc, char *argv[])
{
  char *c, scratch[256];
  int i, cc;
  if (argc < 2) 
  {
dumpUsage:
    for (i=0; i<nUsageLines; i++)
    {
      printf(i == 1 ? "Usage : " : "        ");
      printf("%s\n",usageTxt[i]);
    }
    printf("\n");
    exit(1);
  }
  if (*(argv[1]) == '?' || !strncmp(argv[1],"/?",2)) goto dumpUsage;
  for (i=2; i<argc; i++)
  { /* options given */
    c = argv[i];
    if (*c++ != '/') break;
    switch (tolower(*c))
    {
      case 'd':
        if ((c=strchr(c,'=')) != NULL)
        {
          c++;
          strncpy(scratch,c,32);
          tineDebug = atoi(scratch);      
          foregroundTTY = TRUE;
        }
        continue;
      case '?': goto dumpUsage;
      default:
        continue;
    }
  }  
  MaxNumConnections = 10;
  gListenForGlobals = gListenForMCasts = FALSE;
  MaxPollingRate = MinPollingRate = 200;
  nofeclog = TRUE;
  printf("\n");
  if ((cc=tdevlist(argv[1])) != 0 && !(cc&CE_SENDDATA))
    printf("error : %s\n",erlst[cc]);
  printf("\n");
  return cc;
}
